#include <stdexcept>
#include <iostream>
using namespace std;
template <typename Type>  
class vetor {
private:
    int tam;
    Type * vet;
public:
    vetor(int tam) : tam(tam) {
        vet = new Type[tam]; 
    }     

    Type& operator[]( int i ) throw ( runtime_error ) {
        if( i >= 0 && i < tam )
            return vet[i];
        else {
            runtime_error e( "Índice inválido" );
            throw e;
        }
    }
    
    
    
    bool operator==( vetor<Type> v ) throw ( runtime_error ) {
        if( v.tamanho() != tamanho() )
            return false;
            
        for(int i = 0; i < tamanho(); i++ )
            if( v.vet[i] != vet[i] )
                return false;
        
        return true;
    }
   
   
    int tamanho() {
        return tam;
    }
};

int main() {
    vetor<int>  v(10);
    
    try {
        cout << "TRY" << endl;
        
        v[0] = 2;
        
        cout << "END" << endl;
        v[-1] = 3;
    } catch( string e ) {
        cout << e << endl; 
    }
   
    cout << "END PROG" << endl;
    
    
    
    
}
